Package fr.gouv.vitam.logbook.lifecycles.core

# Class LogbookLifeCyclesImpl

java.lang.Object
fr.gouv.vitam.logbook.lifecycles.core.LogbookLifeCyclesImpl

All Implemented Interfaces:
  `LogbookLifeCycles`

public class LogbookLifeCyclesImpl extends Object implements LogbookLifeCycles
Logbook LifeCycles implementation base class

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LogbookLifeCyclesImpl(LogbookDbAccess mongoDbAccess)`
  Constructor

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `bulk(LogbookCollections collections, String idOp, List<? extends LogbookLifeCycleModel> logbookLifeCycleModels)`
  Bulk method
  `boolean`
  `checkObjectGroupLifecycleEntriesExistenceByLastPersistedDate(String startDate, String endDate)`
  Checks existence of new object group life cycles
  `boolean`
  `checkUnitLifecycleEntriesExistenceByLastPersistedDate(String startDate, String endDate)`
  Checks existence of new unit life cycles
  `void`
  `commitObjectGroup(String idOperation, String idLc)`
  Commits ObjectGroup lifeCycle
  `void`
  `commitUnit(String idOperation, String idLc)`
  Commits Unit lifeCycle
  `void`
  `createBulkLogbookLifecycle(String operationId, LogbookLifeCycleParameters[] lifecycleArray)`
  Create one Logbook Lifecycle with already multiple sub-events
  `void`
  `createObjectGroup(String idOperation, String idLc, LogbookLifeCycleObjectGroupParameters parameters)`
  Create and insert logbook LifeCycle entries
  `void`
  `createUnit(String idOperation, String idLc, LogbookLifeCycleUnitParameters parameters)`
  Create and insert logbook LifeCycle entries
  `void`
  `deleteLifeCycleObjectGroups(List<String> objectGroupIds)`
  delete LifeCycle ObjectGroups
  `void`
  `deleteLifeCycleUnits(List<String> unitsIdentifier)`
  delete LifeCycle Units
  `LifeCycleStatusCode`
  `getObjectGroupLifeCycleStatus(String objectGroupId)`
  Returns the LifeCycle Status for a given objectGroup Id
  `com.fasterxml.jackson.databind.JsonNode`
  `getRawObjectGroupLifeCycleById(String id)`
  returns the raw version of object group life cycle
  `List<com.fasterxml.jackson.databind.JsonNode>`
  `getRawObjectGroupLifeCycleByIds(List<String> ids)`
  returns the raw version of object group life cycle
  `CloseableIterator<com.fasterxml.jackson.databind.JsonNode>`
  `getRawObjectGroupLifecyclesByLastPersistedDate(String startDate, String endDate, int limit)`
  Gets a list of raw object group life cycles by request
  `com.fasterxml.jackson.databind.JsonNode`
  `getRawUnitLifeCycleById(String id)`
  returns the raw version of unit life cycle
  `List<com.fasterxml.jackson.databind.JsonNode>`
  `getRawUnitLifeCycleByIds(List<String> ids)`
  returns the raw version of unit life cycle
  `CloseableIterator<com.fasterxml.jackson.databind.JsonNode>`
  `getRawUnitLifecyclesByLastPersistedDate(String startDate, String endDate, int limit)`
  Gets a list of raw unit life cycles by request
  `LifeCycleStatusCode`
  `getUnitLifeCycleStatus(String unitId)`
  Returns the LifeCycle Status for a given unit Id
  `void`
  `rollbackObjectGroup(String idOperation, String idLc)`
  Rollback logbook LifeCycle entries
  `void`
  `rollBackObjectGroupsByOperation(String idOperation)`
  Removes the created object groups lifeCycles during a given operation
  `void`
  `rollbackUnit(String idOperation, String idLc)`
  Rollback logbook LifeCycle entries
  `void`
  `rollBackUnitsByOperation(String idOperation)`
  Removes the created unit lifeCycles during a given operation
  `LogbookLifeCycle<?>`
  `selectLifeCycleById(String lifecycleId, com.fasterxml.jackson.databind.JsonNode queryDsl, boolean sliced, LogbookCollections collection)`
  Selects life cycle entry
  `List<LogbookLifeCycle<?>>`
  `selectLifeCycles(com.fasterxml.jackson.databind.JsonNode select, boolean sliced, LogbookCollections collection)`
  Selects life cycle entries
  `void`
  `updateBulkLogbookLifecycle(String operationId, LogbookLifeCycleParameters[] lifecycleArray)`
  Update one Logbook Lifecycle with multiple sub-events
  It adds this new entry within the very same Logbook Lifecycle entry in "events" array.
  `void`
  `updateLogbookLifeCycleBulk(LogbookCollections logbookCollections, List<LogbookLifeCycleParametersBulk> logbookLifeCycleParametersBulk)`
  updateLogbookLifeCycleBulk
  `void`
  `updateObjectGroup(String idOperation, String idLc, LogbookLifeCycleObjectGroupParameters parameters)`
  Update logbook LifeCycle entries
  `void`
  `updateObjectGroup(String idOperation, String idLc, LogbookLifeCycleObjectGroupParameters parameters, boolean commit)`
  Update logbook LifeCycle entries
  `void`
  `updateUnit(String idOperation, String idLc, LogbookLifeCycleUnitParameters parameters)`
  Update logbook LifeCycle entries
  `void`
  `updateUnit(String idOperation, String idLc, LogbookLifeCycleUnitParameters parameters, boolean commit)`
  Update logbook LifeCycle entries committed or in progress

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### LogbookLifeCyclesImpl

    public LogbookLifeCyclesImpl(LogbookDbAccess mongoDbAccess)
    Constructor
    Parameters:
      `mongoDbAccess` - of logbook

- ## Method Details

  - ### createUnit

    public void createUnit(String idOperation, String idLc, LogbookLifeCycleUnitParameters parameters) throws LogbookAlreadyExistsException, LogbookDatabaseException, IllegalArgumentException
    Description copied from interface: `LogbookLifeCycles`
    Create and insert logbook LifeCycle entries
    Specified by:
      `createUnit` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle unit identifier
      `parameters` - the logbook lifecycle parameters
    Throws:
      `LogbookAlreadyExistsException` - if an LifeCycle with the same eventIdentifierProcess and outcome="Started" already exists
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `IllegalArgumentException`

  - ### createObjectGroup

    public void createObjectGroup(String idOperation, String idLc, LogbookLifeCycleObjectGroupParameters parameters) throws LogbookAlreadyExistsException, LogbookDatabaseException, IllegalArgumentException
    Description copied from interface: `LogbookLifeCycles`
    Create and insert logbook LifeCycle entries
    Specified by:
      `createObjectGroup` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle identifier
      `parameters` - the logbook lifecycle parameters
    Throws:
      `LogbookAlreadyExistsException` - if an LifeCycle with the same eventIdentifierProcess and outcome="Started" already exists
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `IllegalArgumentException`

  - ### updateUnit

    public void updateUnit(String idOperation, String idLc, LogbookLifeCycleUnitParameters parameters) throws LogbookDatabaseException, IllegalArgumentException, LogbookNotFoundException, LogbookAlreadyExistsException
    Description copied from interface: `LogbookLifeCycles`
    Update logbook LifeCycle entries
    Specified by:
      `updateUnit` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle identifier
      `parameters` - the logbook lifecycle parameters
    Throws:
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookNotFoundException` - if no LifeCycle with the same eventIdentifierProcess exists
      `LogbookAlreadyExistsException` - if the entry already exists
      `IllegalArgumentException`

  - ### updateUnit

    public void updateUnit(String idOperation, String idLc, LogbookLifeCycleUnitParameters parameters, boolean commit) throws LogbookNotFoundException, LogbookDatabaseException, LogbookAlreadyExistsException
    Description copied from interface: `LogbookLifeCycles`
    Update logbook LifeCycle entries committed or in progress
    Specified by:
      `updateUnit` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle identifier
      `parameters` - the logbook lifecycle parameters
      `commit` - if false update in progress collection else update committed LFC
    Throws:
      `LogbookNotFoundException` - if no LifeCycle with the same eventIdentifierProcess exists
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookAlreadyExistsException` - if the entry already exists

  - ### updateObjectGroup

    public void updateObjectGroup(String idOperation, String idLc, LogbookLifeCycleObjectGroupParameters parameters) throws LogbookNotFoundException, LogbookDatabaseException, IllegalArgumentException, LogbookAlreadyExistsException
    Description copied from interface: `LogbookLifeCycles`
    Update logbook LifeCycle entries
    Specified by:
      `updateObjectGroup` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle identifier
      `parameters` - the logbook lifecycle parameters
    Throws:
      `LogbookNotFoundException` - if no LifeCycle with the same eventIdentifierProcess exists
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookAlreadyExistsException` - if the entry already exists
      `IllegalArgumentException`

  - ### updateObjectGroup

    public void updateObjectGroup(String idOperation, String idLc, LogbookLifeCycleObjectGroupParameters parameters, boolean commit) throws LogbookNotFoundException, LogbookDatabaseException, IllegalArgumentException, LogbookAlreadyExistsException
    Description copied from interface: `LogbookLifeCycles`
    Update logbook LifeCycle entries
    Specified by:
      `updateObjectGroup` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle identifier
      `parameters` - the logbook lifecycle parameters
      `commit` - if true update is done on committed collection otherwise on inProcess one
    Throws:
      `LogbookNotFoundException` - if no LifeCycle with the same eventIdentifierProcess exists
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookAlreadyExistsException` - if the entry already exists
      `IllegalArgumentException`

  - ### selectLifeCycleById

    public LogbookLifeCycle<?> selectLifeCycleById(String lifecycleId, com.fasterxml.jackson.databind.JsonNode queryDsl, boolean sliced, LogbookCollections collection) throws LogbookDatabaseException, LogbookNotFoundException, InvalidParseOperationException, VitamDBException, InvalidCreateOperationException
    Description copied from interface: `LogbookLifeCycles`
    Selects life cycle entry
    Specified by:
      `selectLifeCycleById` in interface `LogbookLifeCycles`
    Parameters:
      `lifecycleId` - the lifecycle id
      `queryDsl` - the select projection in format of JsonNode
      `sliced` - the boolean sliced filtering events or not
      `collection` - the collection on which the select operation will be done : Production collection (LIFECYCLE_OBJECT_GROUP/LIFECYCLE_UNIT) or Working collection (LIFECYCLE_OBJECT_GROUP_IN_PROCESS/LIFECYCLE_UNIT_IN_PROCESS)
    Returns:
      the logbook LifeCycle
    Throws:
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookNotFoundException` - if no LifeCycle selected cannot be found
      `InvalidParseOperationException` - if invalid parse for selecting the LifeCycle
      `InvalidParseOperationException` - if invalid parse for selecting the LifeCycle
      `VitamDBException` - in case a desynchro is recorded between Mongo and ES
      `InvalidCreateOperationException`

  - ### selectLifeCycles

    public List<LogbookLifeCycle<?>> selectLifeCycles(com.fasterxml.jackson.databind.JsonNode select, boolean sliced, LogbookCollections collection) throws LogbookDatabaseException, LogbookNotFoundException, VitamDBException
    Description copied from interface: `LogbookLifeCycles`
    Selects life cycle entries
    Specified by:
      `selectLifeCycles` in interface `LogbookLifeCycles`
    Parameters:
      `select` - the select request in format of JsonNode
      `sliced` - the boolean sliced filtering events or not
      `collection` - the collection on which the select operation will be done : Production collection (LIFECYCLE_OBJECT_GROUP/LIFECYCLE_UNIT) or Working collection (LIFECYCLE_OBJECT_GROUP_IN_PROCESS/LIFECYCLE_UNIT_IN_PROCESS)
    Returns:
      List of the logbook LifeCycle
    Throws:
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookNotFoundException` - if no LifeCycle selected cannot be found
      `VitamDBException` - in case a desynchro is recorded between Mongo and ES

  - ### rollbackUnit

    public void rollbackUnit(String idOperation, String idLc) throws LogbookNotFoundException, LogbookDatabaseException, IllegalArgumentException
    Description copied from interface: `LogbookLifeCycles`
    Rollback logbook LifeCycle entries
    Specified by:
      `rollbackUnit` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle identifier
    Throws:
      `LogbookNotFoundException` - if no LifeCycle with the same eventIdentifierProcess exists
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `IllegalArgumentException`

  - ### rollbackObjectGroup

    public void rollbackObjectGroup(String idOperation, String idLc) throws LogbookNotFoundException, LogbookDatabaseException, IllegalArgumentException
    Description copied from interface: `LogbookLifeCycles`
    Rollback logbook LifeCycle entries
    Specified by:
      `rollbackObjectGroup` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle identifier
    Throws:
      `LogbookNotFoundException` - if no LifeCycle with the same eventIdentifierProcess exists
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `IllegalArgumentException`

  - ### createBulkLogbookLifecycle

    public void createBulkLogbookLifecycle(String operationId, LogbookLifeCycleParameters[] lifecycleArray) throws LogbookDatabaseException, LogbookAlreadyExistsException
    Description copied from interface: `LogbookLifeCycles`
    Create one Logbook Lifecycle with already multiple sub-events
    Specified by:
      `createBulkLogbookLifecycle` in interface `LogbookLifeCycles`
    Parameters:
      `operationId` - Operation Id
      `lifecycleArray` - with first and next events to add/update
    Throws:
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookAlreadyExistsException` - if LifeCycle already exists

  - ### updateBulkLogbookLifecycle

    public void updateBulkLogbookLifecycle(String operationId, LogbookLifeCycleParameters[] lifecycleArray) throws LogbookDatabaseException, LogbookNotFoundException, LogbookAlreadyExistsException
    Description copied from interface: `LogbookLifeCycles`
    Update one Logbook Lifecycle with multiple sub-events
    It adds this new entry within the very same Logbook Lifecycle entry in "events" array.
    Specified by:
      `updateBulkLogbookLifecycle` in interface `LogbookLifeCycles`
    Parameters:
      `operationId` - Operation Id
      `lifecycleArray` - containing all Lifecycle Logbook in order
    Throws:
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookNotFoundException` - if LifeCycle cannot be found
      `LogbookAlreadyExistsException` - if LifeCycle already exists

  - ### commitUnit

    public void commitUnit(String idOperation, String idLc) throws LogbookDatabaseException, LogbookNotFoundException, LogbookAlreadyExistsException
    Description copied from interface: `LogbookLifeCycles`
    Commits Unit lifeCycle
    Specified by:
      `commitUnit` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle identifier
    Throws:
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookNotFoundException` - if LifeCycle cannot be found
      `LogbookAlreadyExistsException` - if LifeCycle already exists

  - ### commitObjectGroup

    public void commitObjectGroup(String idOperation, String idLc) throws LogbookDatabaseException, LogbookNotFoundException, LogbookAlreadyExistsException
    Description copied from interface: `LogbookLifeCycles`
    Commits ObjectGroup lifeCycle
    Specified by:
      `commitObjectGroup` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation identifier
      `idLc` - the lifecycle identifier
    Throws:
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookNotFoundException` - if LifeCycle cannot be found
      `LogbookAlreadyExistsException` - if LifeCycle already exists

  - ### rollBackUnitsByOperation

    public void rollBackUnitsByOperation(String idOperation) throws LogbookNotFoundException, LogbookDatabaseException
    Description copied from interface: `LogbookLifeCycles`
    Removes the created unit lifeCycles during a given operation
    Specified by:
      `rollBackUnitsByOperation` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation id
    Throws:
      `LogbookNotFoundException` - if LifeCycle cannot be found
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database

  - ### rollBackObjectGroupsByOperation

    public void rollBackObjectGroupsByOperation(String idOperation) throws LogbookNotFoundException, LogbookDatabaseException
    Description copied from interface: `LogbookLifeCycles`
    Removes the created object groups lifeCycles during a given operation
    Specified by:
      `rollBackObjectGroupsByOperation` in interface `LogbookLifeCycles`
    Parameters:
      `idOperation` - the operation id
    Throws:
      `LogbookNotFoundException` - if LifeCycle cannot be found
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database

  - ### getUnitLifeCycleStatus

    public LifeCycleStatusCode getUnitLifeCycleStatus(String unitId) throws LogbookDatabaseException, LogbookNotFoundException
    Description copied from interface: `LogbookLifeCycles`
    Returns the LifeCycle Status for a given unit Id
    Specified by:
      `getUnitLifeCycleStatus` in interface `LogbookLifeCycles`
    Parameters:
      `unitId` - the unit Id
    Returns:
      the lifeCycleStatusCode
    Throws:
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookNotFoundException` - if LifeCycle cannot be found

  - ### getObjectGroupLifeCycleStatus

    public LifeCycleStatusCode getObjectGroupLifeCycleStatus(String objectGroupId) throws LogbookDatabaseException, LogbookNotFoundException
    Description copied from interface: `LogbookLifeCycles`
    Returns the LifeCycle Status for a given objectGroup Id
    Specified by:
      `getObjectGroupLifeCycleStatus` in interface `LogbookLifeCycles`
    Parameters:
      `objectGroupId` - the objectGroup Id
    Returns:
      the lifeCycleStatusCode
    Throws:
      `LogbookDatabaseException` - if errors occur while connecting or writing to the database
      `LogbookNotFoundException` - if LifeCycle cannot be found

  - ### bulk

    public void bulk(LogbookCollections collections, String idOp, List<? extends LogbookLifeCycleModel> logbookLifeCycleModels) throws DatabaseException
    Description copied from interface: `LogbookLifeCycles`
    Bulk method
    Specified by:
      `bulk` in interface `LogbookLifeCycles`
    Parameters:
      `collections` - the logbook collections
      `idOp` - operation identifier
      `logbookLifeCycleModels` - lifecycles to be created
    Throws:
      `DatabaseException` - if database could not be reached

  - ### getRawUnitLifecyclesByLastPersistedDate

    public CloseableIterator<com.fasterxml.jackson.databind.JsonNode> getRawUnitLifecyclesByLastPersistedDate(String startDate, String endDate, int limit)
    Description copied from interface: `LogbookLifeCycles`
    Gets a list of raw unit life cycles by request
    Specified by:
      `getRawUnitLifecyclesByLastPersistedDate` in interface `LogbookLifeCycles`
    Parameters:
      `startDate` - the selection start date
      `endDate` - the selection end date
      `limit` - the max limit

  - ### getRawObjectGroupLifecyclesByLastPersistedDate

    public CloseableIterator<com.fasterxml.jackson.databind.JsonNode> getRawObjectGroupLifecyclesByLastPersistedDate(String startDate, String endDate, int limit)
    Description copied from interface: `LogbookLifeCycles`
    Gets a list of raw object group life cycles by request
    Specified by:
      `getRawObjectGroupLifecyclesByLastPersistedDate` in interface `LogbookLifeCycles`
    Parameters:
      `startDate` - the selection start date
      `endDate` - the selection end date
      `limit` - the max limit

  - ### checkUnitLifecycleEntriesExistenceByLastPersistedDate

    public boolean checkUnitLifecycleEntriesExistenceByLastPersistedDate(String startDate, String endDate)
    Description copied from interface: `LogbookLifeCycles`
    Checks existence of new unit life cycles
    Specified by:
      `checkUnitLifecycleEntriesExistenceByLastPersistedDate` in interface `LogbookLifeCycles`
    Parameters:
      `startDate` - the selection start date
      `endDate` - the selection end date

  - ### checkObjectGroupLifecycleEntriesExistenceByLastPersistedDate

    public boolean checkObjectGroupLifecycleEntriesExistenceByLastPersistedDate(String startDate, String endDate)
    Description copied from interface: `LogbookLifeCycles`
    Checks existence of new object group life cycles
    Specified by:
      `checkObjectGroupLifecycleEntriesExistenceByLastPersistedDate` in interface `LogbookLifeCycles`
    Parameters:
      `startDate` - the selection start date
      `endDate` - the selection end date

  - ### getRawUnitLifeCycleById

    public com.fasterxml.jackson.databind.JsonNode getRawUnitLifeCycleById(String id) throws LogbookNotFoundException, InvalidParseOperationException
    Description copied from interface: `LogbookLifeCycles`
    returns the raw version of unit life cycle
    Specified by:
      `getRawUnitLifeCycleById` in interface `LogbookLifeCycles`
    Parameters:
      `id` - the id to retrieve
    Returns:
      the unit life cycle
    Throws:
      `LogbookNotFoundException`
      `InvalidParseOperationException`

  - ### getRawUnitLifeCycleByIds

    public List<com.fasterxml.jackson.databind.JsonNode> getRawUnitLifeCycleByIds(List<String> ids) throws LogbookNotFoundException, InvalidParseOperationException
    Description copied from interface: `LogbookLifeCycles`
    returns the raw version of unit life cycle
    Specified by:
      `getRawUnitLifeCycleByIds` in interface `LogbookLifeCycles`
    Parameters:
      `ids` - the ids to retrieve
    Returns:
      the unit life cycle
    Throws:
      `LogbookNotFoundException`
      `InvalidParseOperationException`

  - ### getRawObjectGroupLifeCycleById

    public com.fasterxml.jackson.databind.JsonNode getRawObjectGroupLifeCycleById(String id) throws LogbookNotFoundException, InvalidParseOperationException
    Description copied from interface: `LogbookLifeCycles`
    returns the raw version of object group life cycle
    Specified by:
      `getRawObjectGroupLifeCycleById` in interface `LogbookLifeCycles`
    Parameters:
      `id` - the id to retrieve
    Returns:
      the object group life cycle
    Throws:
      `LogbookNotFoundException`
      `InvalidParseOperationException`

  - ### getRawObjectGroupLifeCycleByIds

    public List<com.fasterxml.jackson.databind.JsonNode> getRawObjectGroupLifeCycleByIds(List<String> ids) throws LogbookNotFoundException, InvalidParseOperationException
    Description copied from interface: `LogbookLifeCycles`
    returns the raw version of object group life cycle
    Specified by:
      `getRawObjectGroupLifeCycleByIds` in interface `LogbookLifeCycles`
    Parameters:
      `ids` - the ids to retrieve
    Returns:
      the object group life cycle
    Throws:
      `LogbookNotFoundException`
      `InvalidParseOperationException`

  - ### updateLogbookLifeCycleBulk

    public void updateLogbookLifeCycleBulk(LogbookCollections logbookCollections, List<LogbookLifeCycleParametersBulk> logbookLifeCycleParametersBulk)
    Description copied from interface: `LogbookLifeCycles`
    updateLogbookLifeCycleBulk
    Specified by:
      `updateLogbookLifeCycleBulk` in interface `LogbookLifeCycles`
    Parameters:
      `logbookCollections` - lifecycleUnitInProcess
      `logbookLifeCycleParametersBulk` - logbookLifeCycleParametersBulk

  - ### deleteLifeCycleObjectGroups

    public void deleteLifeCycleObjectGroups(List<String> objectGroupIds) throws DatabaseException
    Description copied from interface: `LogbookLifeCycles`
    delete LifeCycle ObjectGroups
    Specified by:
      `deleteLifeCycleObjectGroups` in interface `LogbookLifeCycles`
    Parameters:
      `objectGroupIds` - objectGroupIds
    Throws:
      `DatabaseException` - DatabaseException

  - ### deleteLifeCycleUnits

    public void deleteLifeCycleUnits(List<String> unitsIdentifier) throws DatabaseException
    Description copied from interface: `LogbookLifeCycles`
    delete LifeCycle Units
    Specified by:
      `deleteLifeCycleUnits` in interface `LogbookLifeCycles`
    Parameters:
      `unitsIdentifier` - units lfc Identifier
    Throws:
      `DatabaseException` - DatabaseException